<script lang="ts">
import Vue from 'vue';
import { CtfTextBlock } from '../../models';
import type { PropType } from 'vue';
import { kebabCase } from 'lodash';
import {
  ContentfulComponentMixin,
  UseLiteVimeo,
  UseLocalizedVideoSubtitles,
} from '~/mixins';

export default Vue.extend({
  mixins: [ContentfulComponentMixin, UseLiteVimeo, UseLocalizedVideoSubtitles],
  props: {
    data: {
      type: Object as PropType<CtfTextBlock>,
      required: true,
    },
  },
  methods: {
    kebabCase,
    copyClipboard() {
      if (navigator) {
        navigator.clipboard.writeText(`${window.location}`);
      }
    },
  },
});
</script>

<template>
  <SlpContainer>
    <SlpColumn>
      <div v-if="data.header" class="decoration"></div>
      <div v-if="data.header" class="anchor-header">
        <SlpTypography
          :id="headerId"
          variant="heading2-bold"
          class="copy_block__header"
          tag="h2"
          >{{ data.header }}
        </SlpTypography>
        <a :href="`#${headerId}`" @click="copyClipboard()">
          <SlpIcon name="anchor" size="md" variant="marketing" />
        </a>
      </div>
      <div class="copy_block__content copy">
        <div class="block">
          <SlpTypography v-if="data.text" :variant="'body1'" tag="div">
            <div class="copy_block__text" v-html="$md.render(data.text)"></div>
          </SlpTypography>
          <img
            v-if="data.image"
            class="copy_block__image"
            :src="data.image.fields.file.url"
            loading="lazy"
          />
          <div v-if="data.videoUrl" class="copy_block__video">
            <lite-vimeo
              :videoid="getVideoVimeoId(createVideoSource(data.videoUrl))"
              :videotitle="data.header + ' YouTube Video'"
              autoplay
            ></lite-vimeo>
          </div>
          <SlpButton
            v-if="data.ctaText"
            :href="data.ctaUrl"
            :data-ga-name="data.ctaText"
            data-ga-location="body"
            class="copy_block__button"
            >{{ data.ctaText }}</SlpButton
          >
        </div>
      </div>
    </SlpColumn>
  </SlpContainer>
</template>

<style lang="scss" scoped>
.anchor-header {
  display: flex;
  justify-content: space-between;
  a {
    opacity: 0;
    transition: opacity 170ms ease;
    color: inherit;
    display: inline-block;
    padding-top: 17px;
  }
  &:hover,
  &:focus,
  &:active {
    a {
      opacity: 1;
      transition: opacity 170ms ease;
    }
  }
}
.copy_block {
  &__button {
    margin-top: $spacing-16;
  }
  &__header {
    margin-bottom: $spacing-32;
  }
  &__image {
    margin-top: $spacing-32;
    width: 100%;
    &--top {
      margin-bottom: $spacing-64;
    }
  }
  &__video {
    width: 100%;
    display: flex;
    justify-content: center;
    margin-top: $spacing-32;
    lite-vimeo {
      width: 560;
      height: 315;
    }
    @media (max-width: $breakpoint-lg) {
      max-width: 80vw;
    }
  }
}
.decoration {
  height: 4px;
  margin-top: $spacing-96;
  width: 96px;
  border-radius: 20px;
  margin-bottom: $spacing-24;
  background: rgb(255, 203, 215);
  background: linear-gradient(
    90deg,
    rgba(255, 203, 215, 1) 0%,
    rgba(241, 205, 234, 1) 51%,
    rgba(211, 191, 238, 1) 100%
  );
  @media (max-width: $breakpoint-lg) {
    margin-top: $spacing-64;
  }
}

.copy_block__text {
  &:deep table :is(td, th) {
    border: 1px solid $color-surface-900;
    padding: 0.3em;
  }
  &:deep ul {
    list-style: unset;
    padding: revert;
  }
  &:deep h3 {
    // Need to be important to override the typography styles for body-1 in the blocks where there is a small header (h4) in the paragraphs
    font-weight: 600 !important;
    font-size: 23px !important;
    line-height: 32px !important;
    margin-top: $spacing-32;
    margin-bottom: $spacing-24;
  }
  &:deep p {
    margin-bottom: $spacing-16;
  }
  &:deep strong {
    font-weight: bold;
  }
  &:deep p:last-child {
    margin-bottom: 0;
  }

  &:deep blockquote {
    margin: $spacing-32 0;
    padding: $spacing-16 $spacing-24;
    border-left: 4px solid $color-surface-700;
    background-color: $color-surface-100;
    p {
      margin-bottom: 0;
    }
  }

  &:deep table {
    margin: $spacing-32 0;
    border-collapse: collapse;
    width: 100%;
    th,
    td {
      padding: $spacing-16;
      text-align: left;
      border-bottom: 1px solid $color-surface-900;
    }
  }

  &:deep img {
    width: 100%;
  }
}
</style>
